﻿// Convert Image to TextyImage - Adobe Photoshop Script
// Description: Converts current image to a image made with text. 
// Requirements: Adobe Photoshop CS3, or higher
// Version: 0.0.1 -  13/Apr/2015
// Author: Anil Tejwani (anil@tejwani.com)
// Website: http://tejwani.com/
// ============================================================================
// Installation:
// 1. Place two files ("TS TextyImage.js" and "TS-TextyImage.html")  in:
//    PC(32):  C:\Program Files (x86)\Adobe\Adobe Photoshop CS#\Presets\Scripts\
//    PC(64):  C:\Program Files\Adobe\Adobe Photoshop CS# (64 Bit)\Presets\Scripts\
// 2. Restart Photoshop
// 3. Choose File > Scripts > TS TextyImage
// ============================================================================
#target photoshop
function createFillLayer(){var fillLayerRef = app.activeDocument.artLayers.add();fw();fillLayerRef.visible = false;return fillLayerRef;}
function resetDefault(){app.activeDocument.rulerUnits = prefs.originalRulerUnits;for(j=0;j<10;j++){t = app.activeDocument.artLayers.add(); t.remove();}; alert('SUCCESS!!!\n Done Processing, but not saved. \n You may proceed with saving the file...')}function setPreferences(){var prefs = new Object();prefs.originalRulerUnits = preferences.rulerUnits; prefs.str = 'A free Photoshop script from Tejwani.com ';prefs.maxChar = 20000;prefs.color1 = '#333333';prefs.color2 = '#999999';prefs.color3 = '#dddddd';prefs.wpLine=90;app.activeDocument.rulerUnits = Units.PIXELS;prefs.maxImageSize = 1024; return prefs;} function setOptions(){var win, windowResource;windowResource = "dialog { orientation: 'column', alignChildren: ['fill', 'top'], preferredSize:[350, 100], text: 'Photoshop Script - Insert FileName (TextLayer)',margins:10, settingPanel: Group { orientation: 'column',st1: StaticText { text: 'Welcome to image to textyImage convertor' },st2: StaticText { text: '--o-@-@-o------------------------------------------------------------------------' },st4: StaticText { text: 'Text:' },str: EditText { text: 'text to use to fill up the image ... ', size:[350,25], helpTip:'Type in the text you would like to use in the image fillup'}applyButton: Button { text: 'Start converting »', properties:{name:'ok'},size:[350,30] , weight:bold }, alignChildren: 'left',} creditGroup: Group { orientation: 'column', alignChildren: 'right', st6: StaticText { text: 'IMPORTANT: this process may take a while.' },st7: StaticText { text: '' },st8: StaticText { text: '-------------------------------------------------------------------------o-@-@-o-' }, linkText:StaticText { text: 'Visit us: www.tejwani.com/photoshop-scripting/' }, } }";    win = new Window(windowResource); /* apply button */win.settingPanel.applyButton.onClick = function() {prefs.str = win.settingPanel.str.text;return win.close();};    win.creditGroup.linkText.onClick = function() {File(app.path.toString() + "/Presets/Scripts/TS-TextyImage.html").execute();};win.show();    }function csl(thisName,color,bold,italic,ratio){      var colorRef = new SolidColor();    colorRef = hexToRgb(color, colorRef);      var shadowLayerRef = app.activeDocument.artLayers.add();        shadowLayerRef.kind = LayerKind.TEXT;      shadowLayerRef.name = thisName;         var shadowTextRef = shadowLayerRef.textItem;    shadowTextRef.kind = TextType.PARAGRAPHTEXT;     imgWidth = app.activeDocument.width.toString();      imgHeight = app.activeDocument.height.toString();     shadowTextRef.color = colorRef;     shadowTextRef.size =  imgWidth/ratio;      shadowTextRef.fauxBold = bold;      shadowTextRef.fauxItalic = italic;            shadowTextRef.antiAliasMethod = AntiAlias.SMOOTH;      shadowTextRef.justification = Justification.CENTERJUSTIFIED;      shadowTextRef.leading    = 0;     shadowTextRef.contents = createContent(prefs.str , prefs.maxChar);      shadowTextRef.position = [0,0];  shadowTextRef.width =  imgWidth; shadowTextRef.height = imgHeight;     return shadowLayerRef;}function cl(layerRef, thisName,  color, ratio, bold, italic){ thisRef = layerRef.duplicate (layerRef, ElementPlacement.PLACEBEFORE);  thisRef.name = thisName; var thisTextRef = thisRef.textItem; thisTextRef.fauxBold = bold;thisTextRef.fauxItalic = italic; var colorRef = new SolidColor(); colorRef = hexToRgb(color, colorRef);  thisTextRef.color = colorRef; thisTextRef.size = thisTextRef.size * ratio;   return thisRef;    }function p(thisRef) {app.activeDocument.activeLayer = prefs.curLayer; cr(thisRef.name); app.activeDocument.activeLayer = thisRef; mt();}function check(maxSize){if(app.documents.length === 0){alert('No File Open to process');return false;}else if(app.activeDocument.width.toString().replace(' px','') > maxSize || app.activeDocument.height.toString().replace(' px','') > maxSize){alert('Aborting!!!!\n image size above '+maxSize+' px not supported in this version. \n Retry with a smaller image. \n your image is ' + app.activeDocument.width + ' x '+ app.activeDocument.height);return false;}return true;}
function d() {var desc211 = new ActionDescriptor();var ref211 = new ActionReference();  ref211.putProperty(cTID('Clr '), cTID('Clrs'));desc211.putReference(cTID('null'), ref211);executeAction(cTID('Rset'), desc211, DialogModes.NO);};
function hexToRgb(hex, colorRef) {var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);if(result){ colorRef.rgb.red = parseInt(result[1], 16);colorRef.rgb.green =parseInt(result[2], 16);colorRef.rgb.blue =parseInt(result[3], 16);}return colorRef;}
function m(){ if(check(1024)){cTID = function(s) { return app.charIDToTypeID(s); };sTID = function(s) { return app.stringIDToTypeID(s); };        prefs = setPreferences();prefs.curLayer = app.activeDocument.activeLayer; setOptions(); prefs.curLayer.desaturate();fillLayerRef  = createFillLayer();shadowLayerRef = csl('shadow',prefs.color1,true,false,prefs.wpLine);        midtoneLayerRef = cl(shadowLayerRef,'midtone', prefs.color2, 0.95, false, false);highlightLayerRef = cl(midtoneLayerRef,'highlight', prefs.color3, 0.95, false, true); app.activeDocument.rasterizeAllLayers();shadowLayerRef.visible = midtoneLayerRef.visible = highlightLayerRef.visible = false;        p(shadowLayerRef); p(midtoneLayerRef); p(highlightLayerRef); fillLayerRef.visible = true;app.activeDocument.activeLayer = fillLayerRef; app.activeDocument.flatten(); resetDefault();    }else{/*check failed*/}}
function createContent(text, len){var string = ''; while(string.length  < len ){string += text;}return string ;}
function cr(type) {var t = 'Shdw';switch(type){case 'shadow':case 'shadows':t = 'Shdw';break;case 'midtone':case 'midtones':t = 'Mdtn';break; case 'highlight':case 'highlights':t = 'Hghl';break;}var desc123 = new ActionDescriptor();desc123.putEnumerated(cTID('Clrs'), cTID('Clrs'), cTID(t));desc123.putInteger(sTID("colorModel"), 0);executeAction(sTID('colorRange'), desc123, DialogModes.NO);};
function mt() {var desc133 = new ActionDescriptor();desc133.putClass(cTID('Nw  '), cTID('Chnl'));var ref1 = new ActionReference();ref1.putEnumerated(cTID('Chnl'), cTID('Chnl'), cTID('Msk '));desc133.putReference(cTID('At  '), ref1);desc133.putEnumerated(cTID('Usng'), cTID('UsrM'), cTID('RvlS'));executeAction(cTID('Mk  '), desc133, DialogModes.NO);};
function fw() {var desc221 = new ActionDescriptor();     desc221.putEnumerated(cTID('Usng'), cTID('FlCn'), cTID('Wht '));     desc221.putUnitDouble(cTID('Opct'), cTID('#Prc'), 100);     desc221.putEnumerated(cTID('Md  '), cTID('BlnM'), cTID('Nrml'));     executeAction(cTID('Fl  '), desc221, DialogModes.NO); };m();